#ifndef DETECT_LOOP_H
#define DETECT_LOOP_H

//    This file is part of JustMotion.

//    JustMotion is free software: you can redistribute it and/or modify
//    it under the terms of the GNU General Public License as published by
//    the Free Software Foundation, either version 3 of the License, or
//    (at your option) any later version.

//    JustMotion is distributed in the hope that it will be useful,
//    but WITHOUT ANY WARRANTY; without even the implied warranty of
//    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//    GNU General Public License for more details.

#include "common.h"

class DetectLoop : public QObject
{
    Q_OBJECT

private:

    QString       vidAPath;
    QString       vidBPath;
    QString       imgAPath;
    QString       imgBPath;
    QTimer       *pcTimer;
    QTimer       *checkTimer;
    QElapsedTimer eTimer;
    evt_t         eventQue;
    shared_t     *shared;
    bool          starved;

    float       getFloatFromExe(const QByteArray &line);
    QStringList buildArgs(const QString &prev, const QString &next);
    QStringList buildSnapArgs(const QString &vidSrc, const QString &imgPath);
    bool        pathFilter(const QString &path, const QString &subName);

private slots:

    void init();
    void reset();
    void pcBreak();
    void eTimeOut();

public:

    explicit DetectLoop(shared_t *shared, QThread *thr, QObject *parent = nullptr);

    QString statusLine();

public slots:

    void fileFlushed(const QString &path);

signals:

    void starving();
};

#endif // DETECT_LOOP_H
